#include <libxode.h>
#include <etherx.h>
#include <jabber/jabber.h>

#define max__history 20

typedef struct gcu_struct
{
    pool p;
    jid user, id;
    char *nick;
    xmlnode pres;
    struct gcu_struct *next, *prev;
} _gcu, *gcu;

typedef struct message_struct
{
    pool p;
    xmlnode x;
    struct message_struct *next,*prev;
} _message, *message;


typedef struct gcg_struct
{
    pool p;
    jid id;
    gcu users;
    int hc;
    message history;
    char *topic;
    struct gcg_struct *next, *prev;
} _gcg, *gcg;

/* globals */
extern pth_mutex_t s__m;
extern ehandler gc__etherx;
extern gcg gc__groups;

gcg gcg_get(jid id); /* get the group */
gcg gcg_new(jid id); /* create the group */
void gcg_send(gcg g, gcu u, xmlnode x); /* broadcast to the group */
gcu gcu_get(gcg g, jid id); /* get the user from the group else NULL */
gcu gcu_nick(gcg g, char *nick); /* get the user with the nick from the group else NULL */
gcu gcg_user(gcg g, jid id, char *nick); /* insert the new id or update nick, null if collision */
void gcu_del(gcg g, gcu u); /* unlinks and sends message to group */

void gc_bounce(jpacket p, terror terr);
void gc_etherx(epacket e);
void gc_die(void);
void gc_breakdance(jpacket p);
